"use strict";
var ServiceProxy_1 = require("./ServiceProxy");
var Container = (function () {
    function Container() {
        this.services = {};
    }
    Container.prototype.register = function (name, service) {
        this.services[name] = service;
    };
    Container.prototype.get = function (name) {
        return this.services[name];
    };
    Container.prototype.getOsgiService = function (name) {
        return new ServiceProxy_1.default(this.get("cache"), function () {
            return Cqx.getOsgiService(name);
        }, name);
    };
    Container.prototype.getRequestModel = function (path, name) {
        return new ServiceProxy_1.default(this.get("cache"), function () {
            return Cqx.getRequestModel(path, name);
        }, path + "_" + name);
    };
    Container.prototype.getResourceModel = function (path, name) {
        return new ServiceProxy_1.default(this.get("cache"), function () {
            return Cqx.getResourceModel(path, name);
        }, path + "_" + name);
    };
    return Container;
}());
exports.Container = Container;
//# sourceMappingURL=Container.js.map