"use strict";
var ServiceProxy = (function () {
    function ServiceProxy(cache, locator, name) {
        this.cache = cache;
        this.locator = locator;
        this.name = name;
    }
    ServiceProxy.prototype.invoke = function (method) {
        var _this = this;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var cacheKey = this.cache.generateServiceCacheKey(this.name, method, args);
        return this.cache.wrapServiceCall(cacheKey, function () {
            var service = _this.locator();
            var result = service.invoke(method, args);
            if (result == null) {
                return null;
            }
            return JSON.parse(result);
        });
    };
    return ServiceProxy;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = ServiceProxy;
//# sourceMappingURL=ServiceProxy.js.map