"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Sling_1 = require("./Sling");
var ClientSling = (function (_super) {
    __extends(ClientSling, _super);
    function ClientSling(cache, origin) {
        _super.call(this);
        this.cache = cache;
        this.origin = origin;
    }
    ClientSling.prototype.subscribe = function (listener, path, options) {
        var _this = this;
        var depth;
        if (!options || typeof options.depth === "undefined" || options.depth === null) {
            depth = 0;
        }
        else {
            depth = options.depth;
        }
        var resource = this.cache.get(path, depth);
        if (resource === null || typeof resource === "undefined") {
            var depthAsString = void 0;
            if (depth < 0) {
                depthAsString = "infinity";
            }
            else {
                depthAsString = options.depth + "";
            }
            var url = this.origin + path + ".json.html";
            var serverRenderingParam = "serverRendering=disabled";
            var serverRendering = window.location.search.indexOf(serverRenderingParam) >= 0;
            if (serverRendering) {
                url += "?" + serverRenderingParam;
            }
            return window.fetch(url, { credentials: "same-origin" }).then(function (response) {
                if (response.status === 404) {
                    return {};
                }
                else {
                    return response.json();
                }
            }).then(function (json) {
                _this.cache.mergeCache(json);
                listener.changedResource(path, _this.cache.get(path, depth));
            });
        }
        else {
            listener.changedResource(path, resource);
        }
    };
    ClientSling.prototype.renderDialogScript = function (path, resourceType) {
        return this.cache.getScript(path);
    };
    ClientSling.prototype.includeResource = function (path, resourceType) {
        return this.cache.getIncluded(path);
    };
    ClientSling.prototype.getRequestPath = function () {
        return window.location.pathname;
    };
    return ClientSling;
}(Sling_1.AbstractSling));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = ClientSling;
//# sourceMappingURL=ClientSling.js.map