import { ResourceComponent } from "../component/ResourceComponent";
export interface SlingResourceOptions {
    depth?: number;
}
export interface EditDialogData {
    element: string;
    html?: string;
    attributes?: {
        [name: string]: any;
    };
    child?: EditDialogData;
}
export interface Sling {
    subscribe(listener: ResourceComponent<any, any, any>, path: string, options?: SlingResourceOptions): void;
    renderDialogScript(path: string, resourceType: string): EditDialogData;
    includeResource(path: string, resourceType: string): string;
    getRequestPath(): string;
    getContainingPagePath(): string;
}
export declare abstract class AbstractSling implements Sling {
    abstract subscribe(listener: ResourceComponent<any, any, any>, path: string, options?: SlingResourceOptions): void;
    abstract renderDialogScript(path: string, resourceType: string): EditDialogData;
    abstract includeResource(path: string, resourceType: string): string;
    abstract getRequestPath(): string;
    getContainingPagePath(): string;
}
